;;; xpbroadcast.scm - Clement JONQUET - PhD student in Compuer Science - LIRMM - September 2003 ;;;

; This is the experience "teacher-student" where two agents are created and the first learn to the other a new performative

(load "simple.scm")
(load "ambsimple.scm")
(load "simpleobj.scm")
(newline)

;;; Teacher's creation ;;;

(define teacher (simpleobj))
(send teacher 'new1 (list 'teacher))
(send teacher 'loadFileObj2 (list "evalteacher.scm"))
(send teacher 'setGlobalInter (list (cdr (get-pair 'ambevaluate (send teacher 'getGlobalEnv ()) return (lambda () ())))))
(display "Teacher is created...")(newline)

;;; Student's creation ;;;

(define student (simpleobj))
(send student 'new1 (list 'student))
(send student 'loadFileObj2 (list "evalstudent.scm"))
(send student 'setGlobalInter (list (cdr (get-pair 'ambevaluate (send student 'getGlobalEnv ()) return (lambda () ())))))
(display "Student is created...")(newline)

;;; Conversation ;;;

(initialize-conversation teacher student)
(display "Initialisation of the conversation...")(newline)

(define msg1 (make-kqmlmsg 'assertion teacher student '(define (square x) (* x x))))
(define msg2 (make-kqmlmsg 'broadcast teacher student '(order (square 3))))
		

(sendmessage msg1)
(sendmessage msg2)

(conversationLoop teacher student)
(sendmessage msg2)
(conversationLoop teacher student)

;(display "GlobalEnv de teacher...")(print-env (send teacher 'getGlobalEnv ()))(newline)(newline)(newline)
;(display "Env local de teacher...")(print-env (send teacher 'getEnv (list (send student 'getName ()))))(newline)(newline)(newline)
;(display "GlobalEnv de student...")(print-env (send student 'getGlobalEnv ()))(newline)(newline)
;(display "Env local de student...")(print-env (send student 'getEnv (list (send teacher 'getName ()))))(newline)(newline)

;(display "GlobalInter de teacher...")(print-proc (send teacher 'getGlobalInter ()))(newline)(newline)(newline)
;(display "Inter local de teacher...")(print-proc (send teacher 'getInter (list (send student 'getName ()))))(newline)(newline)(newline)
;(display "GlobalInter de student...")(print-proc (send student 'getGlobalInter ()))(newline)(newline)
;(display "Inter local de student...")(print-proc (send student 'getInter (list (send teacher 'getName ()))))(newline)(newline)
